#!/usr/bin/env ruby
#
#  Created by J.D. Northrup on 2006-06-19.
#  http://www.chakahartamusic.com

require 'osc'
include OSC

class MyClient < SimpleClient
  @dest
    
  def initialize(dest='/m1', host='localhost', port='10000')
    @dest = dest
    super(host, port)
  end
  
  def note(pitch=60, amplitude=1.0, duration=1.0)
    Thread.new(pitch, amplitude, duration) do |p, a, d|
      send(Message.new(@dest, 'f'*2, p, a))
      if(duration > 0)
        sleep(d/1000.0) unless (duration < 1)
        send(Message.new(@dest, 'f'*2, p, 0.0))
      end
    end
  end
end

a = MyClient.new


###
# simple runs
#

#1.upto(5) {|i| a.note(30.0+3*i, 1.0, 200.0); sleep 0.1 }



###
# fibonnaci runs
#

def fib(n)
  a = 1
  b = 1
  t = [1, 1]
  while n > 2
    t.push(a+b)
    a = b
    b = t[-1]
    n = n - 1
  end
  t    
end

sleepBase = 0.05

Thread.new {
fibs = fib(80)
fibs.each do |f| 
  p = 40+(3+f%40)
  a.note(p, ((f%3)+1)/2.0, 0)
  sleep sleepBase * 1*(1+(f%4))
end
}

b = MyClient.new('/m2')

Thread.new {
fibs = fib(80)
fibs.each do |f| 
  f -= 5
  p = 30+(3+f%39)
  b.note(p, ((f%4)+1)/3.0, 0)
  sleep sleepBase * 1*(1+(f%6))
end
}

c = MyClient.new('/m3')

Thread.new {
fibs = fib(80)
fibs.each do |f| 
  f += 5
  p = 30+(3+f%39)
  c.note(p, ((f%4)+1)/3.0, 300)
  sleep sleepBase * 1*(1+(f%4))
end
}



# wait for all threads to finish
Thread.list.each do |t| 
  if (Thread.main() != t)
    t.join
  end
end
