#!/usr/bin/env ruby
#
#  Created by J.D. Northrup on 2006-06-19.
#  http://www.chakahartamusic.com

require 'osc'
include OSC

class MyClient < SimpleClient
  def initialize(host='localhost', port='10000')
    super
  end
  
  def note(pitch=60, amplitude=1.0, duration=1.0)
    dest = "/m1"
    send(Message.new(dest, 'f'*2, pitch, amplitude))
    sleep(duration/1000.0)
    send(Message.new(dest, 'f'*2, pitch, 0.0))
  end
end

a = MyClient.new


###
# simple runs
#

1.upto(5) {|i| a.note(30.0+3*i, 1.0, 200.0); sleep 0.1 }

sleep(3)

###
# fibonnaci runs
#

def fib(n)
  a = 1
  b = 1
  t = [1, 1]
  while n > 2
    t.push(a+b)
    a = b
    b = t[-1]
    n = n - 1
  end
  t    
end

fibs = fib(70)
# straight fibonnaci -> midi mapping
fibs[0..10].each { |f| v = f%127; a.note(v, ((f%3)+1)/2.0); puts v; sleep 0.1*((f%2)+1) } 

sleep(3)

# funky mapping, repeating
(fibs[23..29] * 5).each { |f| v = 20+(f%88); a.note(v, ((f%3)+1)/2.0); puts v; sleep 0.1*((f%2)+1) } 


